#!/bin/bash

if [ $# -ge 2 ]; then
echo "Invalid Parameter!"
fi

set -e

#export TIMEFORMAT='%3R'

#TIME_COMMAND_FORMAT="Average total (data+stack+text) memory use: %K ; Maximum resident set size: %M ; Number of times the process was swapped out of main memory: %W; Systems Page Size: %Z; Number of socket messages: received: %r send: %s;  Average resident set size: %t"

TIME_COMMAND_FORMAT="%e"
NUMBER_OF_ROUNDS=10

#for i in queries/*.sql; do echo "./build/bin/psql --file=$i > /dev/null"; done
#for i in queries/*.sql; do echo "/usr/bin/time -f \$TIME_COMMAND_FORMAT -o measurement_results/`basename $i .sql` --append ./build/bin/psql --file=$i > /dev/null"; done

mkdir -p measurement_results
rm -f measurement_results/*

for (( c=0; c<$NUMBER_OF_ROUNDS; c++ )); do
    for (( query_number=1; query_number<=22; query_number++ )); do
#/usr/bin/time -f $TIME_COMMAND_FORMAT -o measurement_results/all_queries --append ./build/bin/psql --file=queries/all_queries.sql > /dev/null
        echo "Execute Query Q$query_number..."
        /usr/bin/time -f $TIME_COMMAND_FORMAT -o measurement_results/Q$query_number --append ./build/bin/psql --file=tpch_queries/Q$query_number.sql > /dev/null
    done
done

    RESULT_FILE_HEADER="Q1"
    for (( query_number=2; query_number<=22; query_number++ )); do
        RESULT_FILE_HEADER="$RESULT_FILE_HEADER\tQ$query_number"
    done

echo -e "$RESULT_FILE_HEADER" > measurement_results/all_results.csv

paste measurement_results/Q1 measurement_results/Q2 measurement_results/Q3 measurement_results/Q4 measurement_results/Q5 measurement_results/Q6 measurement_results/Q7 measurement_results/Q8 measurement_results/Q9 measurement_results/Q10 measurement_results/Q11 measurement_results/Q12 measurement_results/Q13 measurement_results/Q14 measurement_results/Q15 measurement_results/Q16 measurement_results/Q17 measurement_results/Q18 measurement_results/Q19 measurement_results/Q20 measurement_results/Q21 measurement_results/Q22 >> measurement_results/all_results.csv

exit 0
